define([
	"aps/i18n"
], function(
	_
) {
	"use strict";

	var basePattern = "^[1-9]\\d{0,9}([.,]\\d{1,5})?$";
	var allowZeroPattern = "^[0]([.,]\\d{1,5})?$";
	var notAllowZeroPattern = "^[0][.,]\\d{0,4}[1-9]$";

	var consts = {
		// 5 decimal places, max 15, only positive
		numberPattern: basePattern + "|" + allowZeroPattern,
		numberInvalidMessage: _("The value you entered is not valid. Accepted value should be positive, max number of digits in integer part is 10 and max number of decimal places is 5."),

		numberMoreZeroPattern: basePattern + "|" + notAllowZeroPattern,
		numberMoreZeroInvalidMessage: _("The value you entered is not valid. Accepted value should be above zero, max number of digits in integer part is 10 and max number of decimal places is 5.")
	};

	return consts;
});