define([
	"dojo/_base/declare",
	"aps/Memory",
	"dojo/store/util/SimpleQueryEngine",
	"./customization/QueryResults.js"
], function(declare, Memory, SimpleQueryEngine, queryResults){
	return declare([Memory], {

		query: function(query, options){
			var results;

			options  = options || {};
			query	 = query || {};

			if (options && options.apsType)
				options.type = encodeURIComponent(options.apsType);

			if(typeof query !== "string")
				for(var key in query){
					if(query[key] && query[key].test)
						return queryResults(new SimpleQueryEngine(query, options)(this.data));
				}

			var queryOptions = { params: query, sort: options.sort, paging: { start: options.start, count: options.count } };
			var qe = this.queryEngine(queryOptions);
			results = qe(this.data);

			var postOptionsApply = function(rows){
				if(options.count && options.count != Infinity){
					var oldResults = rows;
					rows = rows.slice(options.start, options.start + options.count);
					rows.total = oldResults.length;
				} else {
					rows.total = rows.length;
				}
				return rows;
			};

			if(!results.then){
				results = postOptionsApply(results);
			}

			return queryResults(results);
		}
	});
});